unit ldn031u1;

//HAS FLAW (at the moment (23 Aug 16) I partly fixed it, at least. Maybe
//since then I completely fixed it, and forgot to take this
//note out! If you click the "Quit" button while a conversion is going on,
//the program doesn't quit immediately. but as soon as the conversion
//is over, the "Quit" you tried to invoke will happen. Sorry.
//This may well be a consequence of my dubious "WaitABit" routine.
//It was WORSE before I replace my attempt with the one based on the
//built in "sleep" procedure. That seems to work quite well, apart from
//the little annoyance mentioned. But I haven't used "sleep" before...
//there may be other consequences I don't know about.

//The "wait to quit" "problem" could probably be solved by acheiving the
//"long" sleeps the program needs (1200ms or so) by doing several
//shorter executions with short "sleeps"

//============================
//CURRENTLY--- working on building tmex_suport unit, in particular a
//record returning TMTouchByte. Also, "error messages" function(s).. there.

//This sourcecode demonstrates accessing a Dallas 1-Wire temperature
//   sensor, the DS18B20.
//It is an enhanced version of LDN030, which did more or less what
//   this does, more transparently, less elegantly.
//LDN030 is the subject of a tutorial on using Lazarus for Dallas
//   1-Wire / MicroLan/ TMEX....
//http://sheepdogguides.com/lut/dstl2hello_ds18b20.htm
//... and can be downloaded from a link there.

//TMTouchByte: Returns a byte, if called with $FF in outbyte.
//TMEX API Help states that it will return $FF if MicroLan
//shorted. But! I believe that $FF must not be treated as
//"an error" uncritically... there may be times when the
//chip you went off to read sends you VALID DATA consisting
//of $FF.

//For the future... introduce an "IsMicroLanShorted" funcion. If
//   TMTouchByte($FF) returns $FF, it MAY be because MicroLan is
//   shorted... or it may simply be that the chip you are talking
//   to is currently sending an $FF.

{$mode objfpc}

{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Inifiles, iBTMEXPW, TtureConversions, smallhelpers, tmex_support,
  readings_window;

const vers='22 Aug 16';
      kIniFileName='LDN031ini.txt';
      kBuLableReadRepeatedlyTurnOn='Read Tture Repeatedly';
      kBuLableReadRepeatedlyTurnOff='Stop Reading Repeatedly';


(*This software, at 21 Aug 16, was only good to read
a DS18B20, family code $28. "Turning on" the "read family
code $10" parts probably trivial... but I didn't have a
$10 chip to hand!

The free "1-Wire Viewer" which comes with the TMEX
software is valuable in several ways, not least for
telling me the chip's ID. It said "2E00.0001.34D9.E328",
but the dots in that mean nothing more than the commas
in, say, 1,432,376, or the dashes in a telephone number,
e.g. 1-888-555-1212. They are there only to aid
readabilty.*)

type

  { Tldn031f1 }

  Tldn031f1 = class(TForm)
    buQuit: TButton;
    buTakeTture: TButton;
    buTmpTestThing: TButton;
    buReadRepeatedlyToggle: TButton;
    cbShowRawValues: TCheckBox;
    eChipID0: TEdit;
    eAdapterType: TEdit;
    eWaitBetweenHalvesOfTtureRead: TEdit;
    ePortNum: TEdit;
    laBadFlaw: TLabel;
    laBadFlaw1: TLabel;
    laChipID0b: TLabel;
    laPortNum: TLabel;
    laChipID0a: TLabel;
    laAdapterType: TLabel;
    laWaitBetweenHalvesOfTtureRead: TLabel;
    laThreeConstTweak: TLabel;
    laTutsURL: TLabel;
    laDebug: TLabel;
    laWaitBetweenHalvesOfTtureRead1: TLabel;
    meMsgsConcise: TMemo;
    meMsgs: TMemo;
    tiReadRepeatedly: TTimer;
    tiWaitTimer: TTimer;//tiWaitTimer has two jobs...
    //One I can live with... it is when it
    //is used by WaitBriefly... although even
    //that is somewhat suspect.
    //The other is more dubious, the one where
    //it is used by WaitABit. There, it provides
    //a longer "time out" between the
    //execution of two blocks of code. It is probably
    //a bad way to do this. Would a TIdleTimer be
    //the way to go? (This is copy 1 of 2 of this
    //note.)
    procedure buQuitClick(Sender: TObject);
    procedure buReadRepeatedlyToggleClick(Sender: TObject);
    procedure buTakeTtureClick(Sender: TObject);
    procedure buTmpTestThingClick(Sender: TObject);
    procedure eAdapterTypeChange(Sender: TObject);
    procedure eChipID0Change(Sender: TObject);
    procedure ePortNumChange(Sender: TObject);
    procedure eWaitBetweenHalvesOfTtureReadChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure laBadFlaw1Click(Sender: TObject);
    procedure tiReadRepeatedlyTimer(Sender: TObject);
    procedure tiWaitTimerTimer(Sender: TObject);

  private
    { private declarations }
    //I have split things between "private" and "public"
    //   rather haphazardly.
    bTmp:byte;
    boTmp,boSessionValid,boGoodChipID0,boReadingRepeatedly:boolean;
    wPortNum,wAdapterType,wWaitBetweenHalvesOfTtureRead:word;
    procedure TakeAndDisplayReading;
    procedure WaitABit(wMS:word);
    procedure WaitBriefly(wMS:word);

  public
    { public declarations }
    sTmp:string;
    wTmp:word;
    stabuffForOneWire:array[0..15361]of byte;
    sChipID: array[0..1] of string[20];//Array to allow for
      //future enhancements. Only element 0 in use in LDN031
    siaROM:array[0..9] of smallint;//An extra element... or two!... provided
        //to preclude the accident of providing too few elements.
    liSessHdl:longint;//32-bits, treated as
        //a signed integer (negative 2 billion or so
        //   (10 to the power 9) to positive 2 billion or so)
    siTmp,siPortNum,siAdapterType:smallint;//16-bits, treated as
        //a signed integer (-32768 to +32767) ((DON'T
        //CONFUSE "smallint" and "shortint"!)
    siWaitABitTimeouts:smallint;//used only as part of WaitABit,
        //with tiWaitTimer. (And WaitBriefly?)
    udrTmpTryTmex0:TudrTryTmex0;

  end;

var
  ldn031f1: Tldn031f1;

implementation

{$R *.lfm}

{ Tldn031f1 }

procedure Tldn031f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure Tldn031f1.buReadRepeatedlyToggleClick(Sender: TObject);
//Toggle all that needs to be toggled to switch between
//  taking readings repeatedly, and not doing so.
//How often a reading is taken is determined by the interval
//  set for tiReadRepeatedly. I'd keep it above 2999.
//In long term operation, the memos will eventually fill... but
//  they can hold, I think, 65,00 lines, so for the purposes of
//  this DEMO program, the mechanisms in place are fine.
//  If you want to leave the app monitoring ttures for weeks
//  on end, something will need to be done to deal with memos
//  getting "full"... I think. (They may have a mechanism for
//  "throwing away" excess lines... but I'd rather program in
//  the mechanism to deal with that, rather than rely on
//  someone else's throughness.)
begin
  if boReadingRepeatedly then begin
     boReadingRepeatedly:=false;
     buReadRepeatedlyToggle.Caption:=kBuLableReadRepeatedlyTurnOn;
     tiReadRepeatedly.enabled:=false;
     buTakeTture.enabled:=true;
  end//no ; here
  else begin
     TakeAndDisplayReading;//Do one "by hand", immediately, so
     //user knows that the taking of readings has started.
     //Otherwise first reading isn't until end of first timeout.
     boReadingRepeatedly:=true;
     buReadRepeatedlyToggle.Caption:=kBuLableReadRepeatedlyTurnOff;
     tiReadRepeatedly.enabled:=true;
     buTakeTture.enabled:=false;
  end;//of else of "if boReadingRepeatedly..."
end;

procedure Tldn031f1.buTakeTtureClick(Sender: TObject);
begin
  TakeAndDisplayReading;
end;

procedure Tldn031f1.buTmpTestThingClick(Sender: TObject);
//this button doesn't do anything "important"... it is a scrap
//of my ongoing work on this project. I can put things in
//this event handler as a "cheap and cheerful" way to see what they do.
var udrTmpForTest:TudrTmp_Test;
begin

  sTmp:=ReportErr(0,5,'TMTouchbyte','xxx');//bCallType:byte,siErr:smallint,sLoc:string);
  meMsgsConcise.lines.insert(0,sTmp);
  //udrTmpForTest:=udrTmp_TestTryUDR;
  //showmessage(TB_TmpTrial+udrTmpForTest.sFrmTest);
end;

procedure Tldn031f1.eAdapterTypeChange(Sender: TObject);
begin
//boGoodAdapterType:=true;
try
  siAdapterType:=StrToInt(eAdapterType.text);
  except
  //boGoodAdapterType:=false;
  end;//try.. except
//SeeIfTimeToEnableReadChip;
end;//eAdapterTypeChange

procedure Tldn031f1.eChipID0Change(Sender: TObject);
//Yes! I realize that this routine is not well written!
var bCount:byte;
    sTmpL,sTmpLMinusDecimals:string;
begin
boGoodChipID0:=true;
sChipID[0]:=eChipID0.text;
sTmpLMinusDecimals:='';
for bCount:=1 to length(sChipID[0]) do begin
    if sChipID[0,bCount]<>'.' then
          sTmpLMinusDecimals:=sTmpLMinusDecimals+sChipID[0,bCount];
    end;//for...
//showmessage(sTmpLMinusDecimals);
if length(sTmpLMinusDecimals)<>16 then
  begin
    boGoodChipID0:=false;
    end//no ; here
  else begin
    for bCount:=1 to 16 do begin
       sTmpL:=uppercase(sTmpLMinusDecimals[bCount]);
       if pos(sTmpL,'0123456789ABCDEF')=0 then boGoodChipID0:=false;
       end;//for
    end;//else
sChipID[0]:=sTmpLMinusDecimals;
//SeeIfTimeToEnableReadChip;
end;//eChipIDChange

procedure Tldn031f1.ePortNumChange(Sender: TObject);
begin
//boGoodPortNumber:=true;
try
  siPortNum:=StrToInt(ePortNum.text);
  except
  //boGoodPortNumber:=false;
  end;//try.. except
//SeeIfTimeToEnableReadChip;
//laRes2.caption:=inttostr(wPortNum);
end;//ePortNumChange

procedure Tldn031f1.eWaitBetweenHalvesOfTtureReadChange(Sender: TObject);
begin
//boGoodPortNumber:=true;
try
  wWaitBetweenHalvesOfTtureRead:=
          StrToInt(eWaitBetweenHalvesOfTtureRead.text);
  except
  //boWaitBetweenHalvesOfTtureRead:=false;
  end;//try.. except
//SeeIfTimeToEnableReadChip;
//laRes2.caption:=inttostr(wPortNum);
end;//ePortNumChange

//===================================================================
procedure Tldn031f1.FormCreate(Sender: TObject);
var dfIniFile:TIniFile;//"df" in name from "datafile".
begin
//Next two just good practice. Not essential to using 1-Wire
application.title:='LDN031';//Pop-up on taskbar tab
caption:='LDN031- 1-Wire demostration. Version: '+vers;//Shows in title bar, main window

//tiWaitTimer concerned with....
//  1) WaitABit: dubious "let some time pass" mechanism (which gives 1-Wire
//           tture sensors time to complete a temperature reading.
//  2) WaitBrifly: A much less dubious interval creator.
//See notes elsewhere, too, and keep them all in step!
tiWaitTimer.enabled:=false;

//tiReadRepeatedly is simply for making the application read the
//   temperature sensor repeatedly. I have no qualms about the way
//   it is used.
tiReadRepeatedly.enabled:=false;
boReadingRepeatedly:=false;

//--------------------------------------------------------------
//Read from ini file, or, ini file absent, use hard-coded defaults here.
//Note: There are OnChange handlers on many of the edit boxes

dfIniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+kIniFileName);

with dfIniFile do begin
   ePortNum.text:=ReadString('Port','Number','99');
   eAdapterType.text:=ReadString('Port','AdapterType','99');
   eChipID0.text:=ReadString('Chip','ID-Chip A','1111.2222.3333.4444');
   //eChipID1.text:=ReadString('Chip','ID-Chip B','1111222233334444');
   sTmp:=ReadString('View','Show Raw Values','Y');

   //Determine whether raw values displayed. Anything beginning
   //  'Y' or 'y' will do to turn this on.
   if uppercase(sTmp[1])='Y' then cbShowRawValues.checked:=true//no ; here
        else cbShowRawValues.checked:=false;

   //Set length of delay between "halves" of reading tture.
   //600 is too short, at least sometimes.
   //800 works, at least sometimes, but may be pushing the chip's limit.
   //(Consequences of using "more than enough" (1600?) not entirely clear.)
   eWaitBetweenHalvesOfTtureRead.text:=
       ReadString('Timings','Tture Conversion Allowance','1000');

   //It is quite simple to put the necessary stuff here, and in FormClose,
   //  to make the application remember the posn and size of the windows
   //  between sessions. See...
   //      http://sheepdogguides.com/lut/lt2Nc.htm
   //  for details.

   end;//with...

dfIniFile.Free;

//qTO DO: prepare way for data and error log files.
//qTO DO: "start of session" entries into both.
//qTO DO: One? Both? Only write in batches?

//End of "Read from ini..."

buTmpTestThing.visible:=false;

end;

procedure Tldn031f1.laBadFlaw1Click(Sender: TObject);
begin
end;

procedure Tldn031f1.tiReadRepeatedlyTimer(Sender: TObject);
begin
  TakeAndDisplayReading;
end;

procedure Tldn031f1.FormActivate(Sender: TObject);
begin
boSessionValid:=true;//Initialize

//Start of 1-Wire stuff- try to set up session handle...
liSessHdl:=TMExtendedStartSession(siPortNum,
     siAdapterType,nil);
  //Last parameter slightly problematic. This "solution"
  //  rec'd by forum poster. Alternative:
  //  TMExtendedStartSession(siPortNum,
  //    siAdapterType,myPointer);//This was my "solution"...
  //    may have flaws, may not. Runs okay, doesn't fall over instantly.
  //    Requires a declaration...
  //       myPointer:pointer;//Almost a kludge!

  if liSessHdl<=0 then begin//<=0 is a fail
     //This won't fail "once in a while. If it fails, there
     //   is no point in proceeding.
     showmessage('Call of TMExtendedStartSession failed. '+
       'Shutting down.');
     //qTO DO: need to send concise msg to
         //meMsgsConcise, to prepare way for day
         //when concise messages go to log file.
     close;
     end;

//Do the required-once TMSetup
if boSessionValid then begin
     siTmp:=TMSetup(liSessHdl);
     if siTmp<>1 then begin//<>1 is a fail
        //This won't fail "once in a while. If it fails, there
        //   is no point in proceeding.
        showmessage('Call of TMSetup failed. '+
                     'Shutting down.');
        //qTO DO: need to send concise msg to
            //meMsgsConcise, to prepare way for day
            //when concise messages go to log file.
        end;//.. if siTmp<>1...
     end;//if boSessionValid...

meMsgs.lines.insert(0,'Version of Tmex_Support unit used in this is: '+sVerTmex_Support);
//DO SIMILAR FOR ALL SUPOORT UNITS

end; //FormActivate

procedure Tldn031f1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var dfIniFile:TInifile;
begin
//showmessage('(Tmp for debugging) "FormClose" executed.');
if boSessionValid then begin
   siTmp:=TMEndSession(liSessHdl);
    //TMEndSession does return error codes, which, eventually,
    //   should be looked at, dealt with... but as we are
    //   exiting app at this point, I doubt they are of
    //   much importance.
    //We may pass through here when liSessHdl is no longer valid,
    //   but we didn't know that, and haven't had a chance to
    //   change boSessionValid to false. boSessionValid is still
    //   useful, for saving us going into things that need a handle
    //   when we DO know that the session handle is no longer valid.
   end;

dfIniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+kIniFileName);
with dfIniFile do begin
  WriteString('Port','Number',ePortNum.text);
  WriteString('Port','AdapterType',eAdapterType.text);
  WriteString('Chip','ID-Chip A',eChipID0.text);
  //WriteString('Chip','ID-Chip B',eChipID1.text);
  WriteString('Timings','Tture Conversion Allowance',
      eWaitBetweenHalvesOfTtureRead.text);

  if cbShowRawValues.checked then sTmp:='Yes'//no ; here
      else sTmp:='No';
  WriteString('View','Show Raw Values',sTmp);

  end;//with...
dfIniFile.Free;

end;//FormClose

//===================================================================
procedure Tldn031f1.WaitABit(wMS: word);
//Once upon a time... maybe still... WaitABit and WaitBriefly
//   were almost identical. Do not, however, merge them into
//   one general purpost "Wait" procedure, as the day may come
//   when WaitABit is replaced by an entirely different, better
//   mechanism even though WaitBriefly carries on as before.
//   (Waiting briefly... 10ms??) is no big deal. The periods of
//   time that have to pass during WaitABit (1500ms?) are more
//   problematic with a multitasking OS.)
//wTmp holds how many millisecond the program should wait for.
//It must not make Windows "hang", nor be too demanding of system
//resources.
//The wait interval will be approximate.
//I am not at all convinced that this "wait a bit" has been done
//   well. It "works"... but how robust the solution is, how sparing
//   of system resources, I am not sure.

//Timer should be left NOT enabled at end of WaitABit.

begin

//http://www.freepascal.org/docs-html/rtl/sysutils/sleep.html
//says...
//Sleep suspends the execution of the program for the specified
//number of milliseconds (milliseconds). After the specified
//period has expired, program execution resumes.

sleep(wMS);//I don't know a lot about sleep... but it seems to
//do what I need, minus MOST of the problems my "solution" had.
//DS031 is still "frozen" while sleeping... but "Quit"s are
//processed as soon as the nap is over, and other apps work
//normally during the nap.... I think. Early days. Not exhaustively
//tested.

(*
  //This was my way to make the prgm "WaitABit"....

  tiWaitTimer.enabled:=false;
  tiWaitTimer.interval:=131;//Make this too large, and the delay
  //between processmessages becomes too great. Also, the time
  //interval becomes more approximate. Too small, and more
  //processmessages than necessary are executed. Everything else
  //"self-adjusts". This, you might say, determines the "granularlity"
  //of WaitABit.
  siWaitABitTimeouts:=wMS div tiWaitTimer.interval;//Max allowed: 32k
  tiWaitTimer.enabled:=true;
  repeat
     //application.processmessages;//Can't, for instance, make this...
     //if (siWaitABitTimeouts mod 5)=0 then application.ProcessMessages;...
     laDebug.caption:='WaitABit is executing '+IntToStr(siWaitABitTimeouts);
     application.ProcessMessages;//CRUCIAL. There MUST be one in this loop!
  until siWaitABitTimeouts<1;//siWaitABitTimeouts decremented by timer's timeout.

  tiWaitTimer.enabled:=false;
  laDebug.caption:='WaitABit timeout complete.';

*)

end;//WaitABit

procedure Tldn031f1.WaitBriefly(wMS: word);
//Once upon a time... maybe still... WaitABit and WaitBriefly
//   were almost identical. Do not, however, merge them into
//   one general purpost "Wait" procedure, as the day may come
//   when WaitABit is replaced by an entirely different, better
//   mechanism even though WaitBriefly carries on as before.
//   (Waiting briefly... 10ms??) is no big deal. The periods of
//   time that have to pass during WaitABit (1500ms?) are more
//   problematic with a multitasking OS.)
//wTmp holds how many millisecond the program should wait for.
//It must not make Windows "hang", nor be too demanding of system
//resources.
//The wait interval will be approximate.
//I am not at all convinced that this "wait a bit" has been done
//   well. It "works"... but how robust the solution is, how sparing
//   of system resources, I am not sure.

//Timer should be left NOT enabled at end of WaitABit.

begin
  tiWaitTimer.enabled:=false;
  tiWaitTimer.interval:=11;//Make this too large, and the delay
  //between processmessages becomes too great. Also, the time
  //interval becomes more approximate. Too small, and more
  //processmessages than necessary are executed. Everything else
  //"self-adjusts". This, you might say, determines the "granularlity"
  //of WaitABit.
  siWaitABitTimeouts:=wMS div tiWaitTimer.interval;//Max allowed: 32k
  tiWaitTimer.enabled:=true;
  repeat
     //application.processmessages;//Can't, for instance, make this...
     //if (siWaitABitTimeouts mod 5)=0 then application.ProcessMessages;...
     laDebug.caption:='WaitBriefly is executing '+IntToStr(siWaitABitTimeouts);
     application.ProcessMessages;//CRUCIAL. There MUST be one in this loop!
  until siWaitABitTimeouts<1;//siWaitABitTimeouts decremented by timer's timeout.

  tiWaitTimer.enabled:=false;
  laDebug.caption:='WaitBriefly timeout complete.';
end;//WaitBriefly

procedure Tldn031f1.tiWaitTimerTimer(Sender: TObject);
//tiWaitTimer has two jobs...
//One I can live with... it is when it
//is used by WaitABriefly... although even
//that is somewhat suspect.
//The other is more dubious, the one where
//it is used by WaitABit. There, it provides
//a longer "time out" between the
//execution of two blocks of code. It is probably
//a bad way to do this. Would a TIdleTimer be
//the way to go? (This is copy 2 of 2 of this
//note.)
begin
  dec(siWaitABitTimeouts);
  application.processmessages;//Essential.?.. prgm
  //may freeze if you try to quit while in this loop
  //otherwise?
end;

procedure Tldn031f1.TakeAndDisplayReading;
//A huge procedure, and the heart of this application's machinery.

//TURN INTO A FUNCTION??... which returns a udr with boSuccessful,
    //where-error-occured info if not, and value if was.
//MAKE IT POSS to use this one function to access many chips.
//WRITE UP PRELIM REQ's // EXIT STATE.... is it in here or elsewhere
//  that connection to TMEX services made??
//If turning into a funtion, be careful about how error messages
//  reach outside world. A mixed economy **IS** (?) possible??
//MOVE "and display" out of this. (START THERE?? After considering
//  long range "plans".)
//PUBLISH LDN031 as is BEFORE those tweaks. Finish work to "steamline"...
//  i.e. the stuff done around SOME TMTouchBytes already (do rest... and
//  do similar for other (call TMwhatsit/ deal with error codes) blocks
//  first.

var boErrSeen:boolean;
    bTtureLo,bTtureHi,bChecksumSent:byte;
    wTtureCentiK:word;//Used briefly in conversion for display
const kWaitBetweenTouchByte=1;//Controls how long the "WaitBriefly"s here
  //delay the program. They MAY not be necessary... I put them in when
  //trying to fix something that was caused by something else. But they
  //MAY be necessary, and may NOT be doing any harm. But they may be.
  //In other words, if you find problems, be suspicious!


begin
    boErrSeen:=false;//Establish an initial value.

    //First: Fill the elements of siaROM....

    //The numbers drawn from eChipID0 tell the software
    //the ID of the temperature sensing chip you claim
    //to be on your MicroLan.

    //The software, at the time I write this messy comment could
    //only work with chips having the family code "$28". 1-Wire Viewer
    //told me that my chip's ID was 2E00.0001.34D9.E328
    //(The dot's in that mean nothing more than the commas
    //in, say, 1,432,376, or the dashes in a telephone number,
    //e.g. 1-888-555-1212. They are there only to aid readabilty.

    //** MY ** chip's ID... your's WILL be different... was:
    //2e00.0001.34d9.e328
    //Use the ini file or the edit box to CHANGE what sChipID is set to.

    //siaRom[0]: When this is NOT zero, when TMRom is
       //  called, it will WRITE what is in siaROM 0-7 to the
       //  "right place" in the state buffer for further
       //  TMEX subroutine calls.

       //When siaROM[0] IS zero, TMRom READS FROM the
       //  "right place" in the state buffer, TO the
       //  elements of the siaROM array.

       //The TMEX API Help document says that after
       //  a read... "(the array siaROM will) have
       //  unique ROM (i.e. the chip's ID) in it.
       //  siaROM[0] will have the family code...
       //I don't know if that is true or false...
       //  but I DO know (it cost me three hours)
       //  that when you use TMRom to WRITE a
       //  chip ID to the state buffer, you should
       //  put the chip's family code in siaROM[0];,
       //  the penultimate byte of the chip ID in
       //  siaROM[1], and so on.
       //(As I type this, after the three hours,
       //  I realize that what I tried first was
       //  only "logical" in SOME ways. Filling
       //  the array in the other order is logical
       //  in ways which had not occured to me. Sigh.)

       //The Help doc goes on...
       //  "and siaROM[7] has the 8-bit CRC". This is
       //  suspect. If that's so, a byte of the chip ID
       //  has been lost. I suspect that the CRC is
       //  in fact in siaROM[8]. (Perhaps the 8-bit
       //  CRC is the end byte of what I call "the
       //  chip ID... THAT would make sense, and "solve"
       //  the "problem" of the documentation being
       //  "wrong". Eureka. I've struggled with that
       //  worry for about 30 years. This possible
       //  "answer" occured to me 21 Aug 16. Sigh.

(*

IN THE TMEX API Help Doc I SAW that....

*after* *Reading*.... "(the array, siaROM
will) have unique ROM (i.e. the chip's ID) in it.
siaROM[0] will have the family code..."

I was confused... maybe still am... and thought
that indicated that THAT WHEN WRITING the ID,
you fill the buffer IN THE OTHER ORDER. ARGH.

(Or maybe I was filling it in the opposite direction
than I intended. Sigh.)
*)

   //Chip family code goes in siaRom[0]
   //Remember that at one
   //   point, I was filling siaRom twice...

   FillSiaRom(0);//The parameter is for a later
   //stage in this application's development,
   //when it will be set up to read from multiple
   //tture sensors. The parameter will tell the
   //software which chip is to be read.

    siTmp:=TMRom(liSessHdl,@stabuffForOneWire,@siaROM);
    if siTmp<0 then begin
      //Documentation does not cover the case of a result
      //  OF zero... only of 1 (all well), and values
      //  of LESS THAN zero. See TMEX API Help doc, for
      //  the meanings of the various possible error values.
        meMsgs.lines.insert(0,'TMRom call returned an error:'+
           inttostr(siTmp));//Need to do similar, with concise
           //msg, to meMsgsConcise,  to prepare way for day
           //when concise messages go to log file.
        boErrSeen:=true;
        end;

(*Alternate way to access the chip... faster, than TMStrongAccess,
  but doesn't check chip
  is actually on the MicroLan!

    if boErrSeen=false then begin //first try the next bit...
        siTmp:=TMAccess(liSessHdl,@stabuffForOneWire);
        //TMgAccess has a "built in" reset of the MicroLan, done 1st.
       if siTmp=0 then begin
            meMsgs.lines.insert(0,'TMAccess call returned zero, '+
              'indicating that no chips were seen on the MicroLan.');
            boErrSeen:=true;
            end;
        if siTmp<0 then begin
            meMsgs.lines.insert(0,'TMAccess call returned error code '+
              inttostr(siTmp));
            boErrSeen:=true;
            end;
        //only other case documented is siTmp=1, indicating that
        //at least one chip is on MicroLan... not necessarily the
        //one we asked for, though. But if what we asked for is
        //present, it "has been selected"... i.e. all the others
        //have been "put to sleep", and will "slumber" until the
        //the next reset. (There is a reset "within" TMAccess.)
    end;//... of first "try next bit"
*)

(*Alternate way to access the chip we want. Slower but better in that
    it checks to see the chip is actually available.*)
    if boErrSeen=false then begin //first try the next bit...
        siTmp:=TMStrongAccess(liSessHdl,@stabuffForOneWire);
        //TMStrongAccess has a "built in" reset of the MicroLan, done 1st.
        if siTmp=0 then begin
            meMsgs.lines.insert(0,'TMStrongAccess call returned zero, '+
              'indicating that the specified chip not on the MicroLan.');
            boErrSeen:=true;
            end;
        if siTmp<0 then begin
            meMsgs.lines.insert(0,'TMStrongAccess call returned error code '+
              inttostr(siTmp));
            boErrSeen:=true;
            end;
        //only other case documented is siTmp=1, indicating that
        //at least one chip is on MicroLan... not necessarily the
        //one we asked for, though. But if what we asked for is
        //present, it "has been selected"... i.e. all the others
        //have been "put to sleep", and will "slumber" until the
        //the next reset. (There is a reset "within" TMAccess.)
    end;//... of first "try next bit"


//if BoErrSeen is still false, we now have our chip selected. The
//code above here will be the same for whatever chip we
//want to work with. The code BELOW here is specific
//to a particular type of 1-Wire chip, in this case, a DS18B20.

(*end "alternate way to access the chip*)

//The DS18B20 is a little tedious to work with, but its function
//(temperature sensing) is so widely useful, that I decided to use
//it in this example, anyway.

//With the DS18B20 (and other temperature sensing chips) we have
//to go through the whole 1-Wire "access the chip/ do things with it"
//business TWICE! (The first pass tells the chip to TAKE a temperature
//reading. The second says "tell the Master what you saw".

//You have to arrange for a short (in human terms, long in computer
//  operation terms) delay between the two blocks of code.

//With many Dallas 1-Wire chips, you have an option to use them via
//"parasitic" power, or with power supplied directly. The code example
//below was written for a chip operating on parasitic power.

//(You ARE operating on parasitic power if there are only two wires
//connected to your DS18B20... the "data" line, and the ground, both
//going off to the adapter plugged into "the master", the PC "running
//things".)

    if boErrSeen=false then begin //try 1st chip specific bit...
        //Send message to chip telling it to take a reading
        siTmp:=TMTouchByte(liSessHdl,$44);
        if siTmp=255 then begin
                meMsgs.lines.insert(0,'TMTouchByte call returned report '+
                  'that the MicroLan was shorted at time of $44 command.');
                boErrSeen:=true;
                end;
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMTouchByte call returned error '+
                  'code '+inttostr(siTmp)+' at time of $44 command. '+
                  'See TMEX Hardware Specific '+
                  'Error Return Code for interpretation.');
                boErrSeen:=true;
                end;
        //Else, siTmp holds a byte returned by the call, but it is of
        //  little interest, not being an error code.
        end;//... of first "try 1st chip specific bit"

//At this point, for reading ttures, when we are using parasitic
//power, we need to set the 1-Wire level to strong pull up, and wait a bit.
    if boErrSeen=false then begin
        siTmp:=TMOneWireLevel(liSessHdl,0,1,0);
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMOneWireLevel call to set '+
                  'strong pull up returned error '+
                  'code '+inttostr(siTmp)+' See TMEX API Help '+
                  'for interpretation.');
                boErrSeen:=true;
                end;
        end;


//I'm not at all convinced that my "WaitABit" does this by the
//best (or even good) means... but it seems, up to a point, to "work"....
    if boErrSeen=false then WaitABit(wWaitBetweenHalvesOfTtureRead);

//Return 1-Wire level to normal value.
    if boErrSeen=false then begin
        siTmp:=TMOneWireLevel(liSessHdl,0,0,0);
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMOneWireLevel call to clear '+
                  'strong pull up returned error '+
                  'code '+inttostr(siTmp)+' See TMEX API Help '+
                  'for interpretation.');
                boErrSeen:=true;
                end;
        end;

//========================================================
//(As ever: If boErrSeen still false...)
//Start "Access chip, etc"... and tell it to report readings.

(*At this point, we should have made a conversion.

FETCHING the value out of the chip requires us to go back to the
beginning, reset the MircoLan, read the value out of the chip, which
it will still be holding, awaiting our return to fetch it. Sigh.

It *MAY* NOT actually be necessary to refill the elements
of siaROM. But I didn't want to take a chance that they
might have become corrupted... say during the call of TMRom?*)

//Fill siaRom again. (See more detailed notes above.)
//If this second "fill" written out, be sure to revise
//   comment further up, which currently mentions this
//   second "fill".

FillSiaRom(0);//The parameter is for a later
//stage in this application's development,
//when it will be set up to read from multiple
//tture sensors. The parameter will tell the
//software which chip is to be read.

siTmp:=TMRom(liSessHdl,@stabuffForOneWire,@siaROM);
if siTmp<0 then begin
  //Documentation does not cover the case of a result
  //  OF zero... only of 1 (all well), and values
  //  of LESS THAN zero. See TMEX API Help doc, for
  //  the meanings of the various possible error values.
    meMsgs.lines.insert(0,'TMRom call returned an error:'+
       inttostr(siTmp));
    boErrSeen:=true;
    end;
(*End of refill ROM*)

if boErrSeen=false then begin //now do TMAccess again...
//We've recently done a TMStrongAccess, so TMAccess should
//suffice here. (Faster, but doesn't check chip is actually
//present.)
    siTmp:=TMAccess(liSessHdl,@stabuffForOneWire);
    //TMAccess does a reset of the MicroLan first.
    if siTmp=0 then begin
        meMsgs.lines.insert(0,'2nd TMAccess call returned zero, '+
          'indicating that no chips were seen on the MicroLan.');
        boErrSeen:=true;
        end;
    if siTmp<0 then begin
        meMsgs.lines.insert(0,'2nd TMAccess call returned error code '+
          inttostr(siTmp));
        boErrSeen:=true;
        end;
    //only other case documented is siTmp=1, indicating that
    //at least one chip is on MicroLan... not necessarily the
    //one we asked for, though. But if what we asked for is
    //present, it "has been selected"... i.e. all the others
    //have been "put to sleep", and will "slumber" until the
    //the next reset. (There is a reset "within" TMAccess.)
end;//... of first "try next bit"


//if BoErrSeen is still false, we now have our chip selected again.
//... so begin the chip-specific code for the "read what was seen" part...
if boErrSeen=false then begin
siTmp:=TMTouchByte(liSessHdl,$BE);//Send "Read Scratchpad" command
   //(TMEX name. "Transmit scratchpad" might have been a better name)
 if siTmp=255 then begin
         meMsgs.lines.insert(0,'TMTouchByte call returned report '+
           'that the MicroLan was shorted at time of $BE command.');
         boErrSeen:=true;
         end;
 if siTmp<0 then begin
         meMsgs.lines.insert(0,'TMTouchByte call returned error '+
           'code '+inttostr(siTmp)+' at time of $BE command. '+
           'See TMEX Hardware Specific '+
           'Error Return Code for interpretation.');
         boErrSeen:=true;
         end;
 //Else, siTmp holds a byte returned by the call, but it is of
 //  little interest, not being an error code.
 end;//... of first "try 1st chip specific bit"

//===================================================
//Read the 9 bytes which will come from the chip...
//---------------------------------------------------
//First byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  DoReports(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822a');
  //Params: group code, error code from TMEX, what routine, where in code.
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bTtureLo:=udrTmpTryTmex0.siResult;//Make a note of result... was chopped
   //to 8 bits in SR. It contains part of the temperature we're
   //trying to read.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//Second byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822b');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bTtureHi:=udrTmpTryTmex0.siResult;//Make a note of result... was chopped
   //to 8 bits in SR. It contains part of the temperature we're
   //trying to read.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

(*Following "should" work... and does, mostly.

But you can't assume that any time you get an
$FF from TMTouchByte it is an error.

MAYBE the MicroLan wasn't "surviving"
  the multiple rapid TMTouchBytes, OR the "$FF is
  an error code" advice in the TMEX API Help is
  misleading. 23 Aug 16, I lean towards the view
  (and have adapted udrTryTMTouchByteRead) that
  $FF MAY mean that the MicroLan is shorted... but
  ALSO it may simply be that the byte the chip you
  are listening to is SENDING $FF.

I put in the WaitBriefly calls before it occured
  to me that I might have failed to grasp all
  of the above, i.e. while I was still thinking
  that $FF must be an error.

When the checksum is used, that will help clear
  things up.
*)

//YES.. following could be done "cleverly"... but that might
//obscure the Very Boring stuff that is going on here...

//3rd byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822c');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//4th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822d');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//5th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822e');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//6th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822f');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//7th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822g');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//8th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822h');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   //Nothing... throw byte away.
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//9th byte.... last...
//And finally, read one more byte, which is a checksum
//calculated from the previous 8.
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
  sTmp:=ReportErr(0,udrTmpTryTmex0.siResult,'TMTouchbyte','16822i');
  //Params: group code, error code from TMEX, what routine, where in code.
  meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
  boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bChecksumSent:=udrTmpTryTmex0.siResult;
   //HMM... is it an 8bit checksum, or 16? IF 16 THREE THINGS NEED FIXING...
   //in udrTmpTryTmex0 siResult should not be stripped down to LS 8 bits,
   //and in read of first two bytes, the value returnen needs to be
   //stripped down to LS 8 bits before being stored in bTtureHi and bTtureLo
   end;//of else of "if boFail..."
end;//boErrSeen=false

//See if bChecksumSent was what it ought to be.(We'll need to re-write
//above slightly, either to calculate checksum as we
//go along, or to have the 8 bytes available to plug
//into the algorithm.)
if boErrSeen=false then begin
//((TO BE DONE))
//Revise note above about "When the checksum is used, that will help
//  clear things up." when the checking-by-checksum done.
end;//boErrSeen=false

(*Same code fine for READING DS1820 and DS18B20...
  How the two bytes returned from the chip needs to be
     INTERPRETED is what is different between the operation of the chips.
  Family codes for 1820 and DS18B20: $10 and $28 respectively.

  DS048 has routines for both, and has a "switch" like...
  if (baDMLRomID[bIdx,0]=$10) then rsTmp:=rRawToC(bTmp,bTmp2);
  if (baDMLRomID[bIdx,0]=$28) then rsTmp:=rRawToC18B20(bTmp,bTmp2);

  (The "rRawToC18B20" was taken from DS048's code with little
   hassle.)
*)


//At this point, we "have" the temperature reading from the sensor!!!
//   **  (^_^)  **

//Now use it, converting from the "raw" "Dallas numbers" to human-
//  friendly numbers along the way.

    if boErrSeen=false then begin //report readings, if boErrSeen false
    if cbShowRawValues.checked then //no "begin
         ReadingsF1.meReadings.lines.insert(0,'^^^The raw values from the chip were: '+
         inttostr(bTtureHi)+'  '+inttostr(bTtureLo)+
         ' (Basis of value shown above)');
    //if rbShow... then... had no "begin". So no "end"


//We have to take those two bytes, and "do things" to turn them
//  into a reading in Celcius degrees. That's "easy",
//  compared to a direct conversion to Fahrenheit degrees.
//  If we want Fahrenheit, our best bet is to convert to C
//  first, and convert from there, if we want to.

//Also note, as hinted at above: At least two of the 1-Wire
//  temperature sensor chips work just like one
//  another UP TO HERE... but from here, you convert from the
//  two bytes the chip gives you to Celcius degrees with different
//  algorithms. The one presented here works for DS18B20 chips. See
//  the datasheet for that chip and the datasheet for your chips to see
//  whether your chips encode the data in the same way.

//The Dallas engineers made their choices for good reasons... but it
// gave us a little extra work, if we want degrees Celcius.
//I'm going to make another choice that still leaves us not using
// degrees C, but which I hope you will agree has its merits. I
// WILL show you how to DISPLAY the reading from your chip in degrees C.

//My choice is to convert values in bTtureLo, bTtureHi to a temperature
//  expressed in HUNDRETHS of degrees Kelvin. The Dallas
//  chips sort of work in Celcius, which is Kelvin +273.15 Using
//  centi-degrees K (inside the program) means that you
//  don't need the hassles of floating point numbers, or signed numbers.
//  (You can, of course, display the ttures in any units, with a simple
//  conversion occurring just before the tture appears.)
//
//Range: If a 16-bit unsigned variable is used for the tture, you can
//  express any tture from absolute zero to 655.35 Kelvin, which is about
//  382 Celcius...  which will, I hope, "do"?

//While both the DS1820 (family code $10) and the DS18B20 (family code $28)
//  are "driven" the same way, you have to interpret the results differently,
//  hence the inclusion of the chip's family code in what follows...

   bTmp:=0;
   if copy(sChipID[bTmp],15,2)<>'28' then begin
      showmessage('The chip ID currently specified by the hard coded '+
        'constant near the top of the program has a "chip family code" '+
        'which this program cannot work with. (It can only handle chips '+
        'from family code $28, i.e. DS18B20s. Alterations to make it '+
        'capable of dealing with family code $10 would not be difficult.) '+
        'Application will close.');
      close;
      end;

   bTmp:=0;
   wTtureCentiK:=wRawTTureToCentiK(bTtureLo,bTtureHi,
                    strtoint('$'+copy(sChipID[bTmp],15,2)));
   (*IMPLEMENT THE FOLLOWING TWO USES OF ERROR CODES ALREADY WRITTEN INTO FUNCTION...
   if wRawTTureToCentiK:=65535 then general fail
   if wRawTTureToCentiK:=65534 then invalid chip family      *)

   //wRawTTureToCentiK can also return valid results if
   //The third parameter is $10, I believe. The "if code <>$28" code
   //   just above here is there simply because I don't have TIME
   //   to TEST that belief at the moment!

   //showmessage(inttostr(wTtureCentiK));

   ReadingsF1.meReadings.lines.insert(0,sFixedWidth(9,' ',sTtureCfrmCentiK(wTtureCentiK))+
       ' degrees C: ~'+sBarGraph(15,37,40,(wTtureCentiK-27315)/100)+'~');

   end;//report readings, if boErrSeen false

end;//procedure TakeAndDisplayReading;

end.
